const choiceArray = [
	["Label", "Object, OA, Person, Letter, Place", "label"],
	["Identificatore", "Object, OA, Person, Letter, Place", "identifier"], 
	["Dimensione", "Object, OA", "dimension"],
	["Materia", "Object, OA", "material"],
	["Localizzazione", "Object, OA", "localization"],
	["Tecnica", "OA", "technique"],
	["Artista", "OA", "artist"],
	["Soggetto", "OA", "subject"],
	["Titolo", "Object, Inf", "title"],
	["Tipo", "Object, Inf", "type"],
	["Note", "Object, OA", "notes"],
	["Riferimenti", "Object, Inf", "references"],
	["Nome proprio", "Person", "givenName"],
	["Nome di famiglia", "Person", "familyName"],
	["Patronimico", "Person", "patronymic"],
	["Luogo di Nascita", "Person", "birthPlace"],
	["Luogo di Morte", "Person", "deathPlace"],
	["Genere", "Person", "sex"],
	["Data di Nascita", "Person", "birthDate"],
	["Data di Morte", "Person", "deathDate"],
	["Occupazione", "Person", "occupation"],
	["Qualifica", "Person", "qualification"],
	["Gruppi di appartenenza", "Person", "groups"],
	["Mittente", "Letter", "sender"],
	["Destinatario", "Letter", "receiver"],
	["Luogo di Partenza", "Letter", "startPlace"],
	["Luogo di Arrivo", "Letter", "endPlace"],
	["Data partenza", "Letter", "startDate"],
	["Data arrivo", "Letter", "endDate"],
	["Lingua", "Letter", "language"],
	["Area linguistica", "Letter", "languageArea"],
	["Edizione", "Letter", "edition"],
	["Antroponimo", "Letter", "antroponym"],
	["Toponimo", "Letter", "toponym"],
	["Data", "Object, OA", "date"]
	];

const typeArray = [
	["Oggetto", "Object"], 
	["Lettera", "Letter"],
	["Opera d'Arte", "OA"],
	["Persona", "Person"],
	["Luogo", "Place"]
	];

const graphArray = [
	["ASPO - Datini", "http://dev.restore.ovi.cnr.it:8890/aspo/datini"], 
	["ASPO - Ospedale", "http://dev.restore.ovi.cnr.it:8890/aspo/ospedale"],
	["ASPO - Marcovaldi", "http://dev.restore.ovi.cnr.it:8890/aspo/marcovaldi"],
	["ASPO - Gettatelli", "http://dev.restore.ovi.cnr.it:8890/aspo/gettatelli"],
	["ASPO - Autori ASPO", "http://dev.restore.ovi.cnr.it:8890/aspo/actors"],
	["MPP - Collezione Martini", "http://dev.restore.ovi.cnr.it:8890/mpp/martini"],
	["MPP - Collezione Ospedale", "http://dev.restore.ovi.cnr.it:8890/mpp/ospedale"],
	["MPP - Collezione Datini", "http://dev.restore.ovi.cnr.it:8890/mpp/datini"],
	["OVI - Lettere", "http://dev.restore.ovi.cnr.it:8890/ovi/datini"]
	];

const objectArray = [];
const personArray = [];
const placeArray = [];
const oaArray = [];
const letterArray = [];

$(document).ready(function () {
	//#######################################

	var type_selector = document.getElementById("type_selector");
	var collection_selector = document.getElementById("collection_selector");

	let x = typeArray.length;

	for(var i=0; i<x; i++) {
		   var opt = document.createElement("option");
		   opt.value= typeArray[i][1];
		   opt.innerHTML = typeArray[i][0]; // whatever property it has

		   // then append it to the select element
		   type_selector.add(opt);
		}

	let y = graphArray.length;

	for(var i=0; i<y; i++) {
		   var opt = document.createElement("option");
		   opt.value= graphArray[i][1];
		   opt.innerHTML = graphArray[i][0]; // whatever property it has

		   // then append it to the select element
		   collection_selector.add(opt);
		}

	let z = choiceArray.length;

	for(var i=0; i<z; i++) {
			var cat = choiceArray[i][1];
			if (cat.includes("Object")) {
				objectArray.push(choiceArray[i]);
			}
			if (cat.includes("OA")) {
				oaArray.push(choiceArray[i]);
			}
			if (cat.includes("Person")) {
				personArray.push(choiceArray[i]);
			}
			if (cat.includes("Letter")) {
				letterArray.push(choiceArray[i]);
			}
			if (cat.includes("Place")) {
				placeArray.push(choiceArray[i]);
			}
		}

	$("#type_selector").change(function(){
        $(this).find("option:selected").each(function(){
            var optionValue = $(this).attr("value");
            if(optionValue){
                $(".box").not("." + optionValue).hide();
                $("." + optionValue).show();
            } else{
                $(".box").hide();
            }
        });
    }).change();

    /*$('[name=sel-parent]').on('change', function() {
	   $(this).attr("id", 'example' + $(this).name());
	});*/


});


function populateOptions(selector, myArray) {

	var choice_selector = document.getElementById(selector);

	let k = myArray.length;

	for(var i=0; i<k; i++) {
		   var opt = document.createElement("option");
		   opt.value= myArray[i][1];
		   opt.innerHTML = myArray[i][0]; // whatever property it has

		   // then append it to the select element
		   choice_selector.add(opt);
		}

	$('#' + selector).on( "change", function() {
		
		var numberId= selector.split("-")[1]
		var inputText=  $( this ).find(":selected").text();
		/*$('#inputchoiceSelector_' +  numberId).val(inputText);
		$('#inputchoiceSelector_' +  numberId).id(inputText);*/
	});
}

var val = 0;

function addToList() {
	val = val+1;
	var sel = '<div id="box_' + val + '" class="container_choice"><div class="remove"><a onclick="removeElement(\'box_' + val + '\')"><i class="fa fa-trash" aria-hidden="true"></i></a></div><div class="choice_box"><select id ="choice_selector-' + val + '" value=' + val + ' name="sel-parent" class="advanced-form-select" aria-label="Default select example"> \
			  <option selected value="0">Scegli un\'opzione</option> \
			  <input type="text" id="inputchoiceSelector_'+ val +'" class="selected_option" placeholder="Enter search terms" aria-label="Enter search terms" aria-describedby="button-addon2"> \
			</select></div></div>';
	$('#drop-down-content').append(sel);
	var selector = 'choice_selector-' + val;
	populateOptions(selector, choiceArray);
}

function addToListObject() {
	val = val+100;
	var sel = '<div id="box_' + val + '" class="container_choice"><div class="remove"><a onclick="removeElement(\'box_' + val + '\')"><i class="fa fa-trash" aria-hidden="true"></i></a></div><div class="choice_box"><select id ="choice_selector-' + val + '" value=' + val + ' name="sel-parent" class="advanced-form-select" aria-label="Default select example"> \
			  <option selected value="0">Scegli un\'opzione</option> \
			  <input type="text" id="inputchoiceSelector_'+ val +'" class="selected_option" placeholder="Enter search terms" aria-label="Enter search terms" aria-describedby="button-addon2"> \
			</select></div></div>';
	$('#drop-down-content-Object').append(sel);
	var selector = 'choice_selector-' + val;
	populateOptions(selector, objectArray);
}

function addToListOA() {
	val = val+200;
	var sel = '<div id="box_' + val + '" class="container_choice"><div class="remove"><a onclick="removeElement(\'box_' + val + '\')"><i class="fa fa-trash" aria-hidden="true"></i></a></div><div class="choice_box"><select id ="choice_selector-' + val + '" value=' + val + ' name="sel-parent" class="advanced-form-select" aria-label="Default select example"> \
			  <option selected value="0">Scegli un\'opzione</option> \
			  <input type="text" id="inputchoiceSelector_'+ val +'" class="selected_option" placeholder="Enter search terms" aria-label="Enter search terms" aria-describedby="button-addon2"> \
			</select></div></div>';
	$('#drop-down-content-OA').append(sel);
	var selector = 'choice_selector-' + val;
	populateOptions(selector, oaArray);
}

function addToListPerson() {
	val = val+300;
	var sel = '<div id="box_' + val + '" class="container_choice"><div class="remove"><a onclick="removeElement(\'box_' + val + '\')"><i class="fa fa-trash" aria-hidden="true"></i></a></div><div class="choice_box"><select id ="choice_selector-' + val + '" value=' + val + ' name="sel-parent" class="advanced-form-select" aria-label="Default select example"> \
			  <option selected value="0">Scegli un\'opzione</option> \
			  <input type="text" id="inputchoiceSelector_'+ val +'" class="selected_option" placeholder="Enter search terms" aria-label="Enter search terms" aria-describedby="button-addon2"> \
			</select></div></div>';
	$('#drop-down-content-Person').append(sel);
	var selector = 'choice_selector-' + val;
	populateOptions(selector, personArray);
}

function addToListLetter() {
	val = val+400;
	var sel = '<div id="box_' + val + '" class="container_choice"><div class="remove"><a onclick="removeElement(\'box_' + val + '\')"><i class="fa fa-trash" aria-hidden="true"></i></a></div><div class="choice_box"><select id ="choice_selector-' + val + '" value=' + val + ' name="sel-parent" class="advanced-form-select" aria-label="Default select example"> \
			  <option selected value="0">Scegli un\'opzione</option> \
			  <input type="text" id="inputchoiceSelector_'+ val +'" class="selected_option" placeholder="Enter search terms" aria-label="Enter search terms" aria-describedby="button-addon2"> \
			</select></div></div>';
	$('#drop-down-content-Letter').append(sel);
	var selector = 'choice_selector-' + val;
	populateOptions(selector, letterArray);
}

function addToListPlace() {
	val = val+500;
	var sel = '<div id="box_' + val + '" class="container_choice"><div class="remove"><a onclick="removeElement(\'box_' + val + '\')"><i class="fa fa-trash" aria-hidden="true"></i></a></div><div class="choice_box"><select id ="choice_selector-' + val + '" value=' + val + ' name="sel-parent" class="advanced-form-select" aria-label="Default select example"> \
			  <option selected value="0">Scegli un\'opzione</option> \
			  <input type="text" id="inputchoiceSelector_'+ val +'" class="selected_option" placeholder="Enter search terms" aria-label="Enter search terms" aria-describedby="button-addon2"> \
			</select></div></div>';
	$('#drop-down-content-Place').append(sel);
	var selector = 'choice_selector-' + val;
	populateOptions(selector, placeArray);
}


//Get parameters from select and input options to build the query
function getParameters() {
	const arr = [];
	const collection = document.getElementsByClassName("advanced-form-select");
	for (let i = 0; i < collection.length; i++) {
	  var x = collection[i].id;
	  var t = document.getElementById(x);
	  var e = t.options[t.selectedIndex].text;
	  var numberId= x.split("-")[1]
	  var inputId = "inputchoiceSelector_" + numberId;
	  var inputText = document.getElementById(inputId).value;
	  var el = [e, inputText];
	  arr.push(el);
	}

	constructQuery(arr);
	/*$('#query_results').append(arr);
	testo = $('input#writeText').val();*/
}

function removeElement(id_element) {
  const element = document.getElementById(id_element);

  element.remove();
}


//Build query with harvested parametes
function constructQuery(params) {

	var g = document.getElementById("collection_selector");
	var graph = g.value;

	var search_graph = "?g";

	if (graph != "") {
		search_graph = '<' + graph + '>';
	} 

	var search_type = "";

	var ct = document.getElementById("type_selector");
	var choosen_type = ct.value;

	console.log(choosen_type);

	if (choosen_type == "Object") {
		search_type = "?subject rdf:type crm:E22_Man-Made_Object . ";
	}
	/*if (choosen_type == "Person") {
		search_type = "?subject rdf:type crm:E21_Person . ";
	}
	if (choosen_type == "Place") {
		search_type = "?subject rdf:type crm:E53_Place . ";
	}*/

	//Letter, OA, Person, Place

	var label = ""; //
	var identificatore = ""; //
	var dimensione = ""; //
	var materia = ""; //
	var localizzazione = ""; //
	var tecnica = ""; //
	var artista = ""; //
	var soggetto = ""; //
	var titolo = ""; //
	var tipo = ""; //
	var note = ""; //
	var riferimenti = ""; //
	var nome_proprio = ""; //
	var nome_di_famiglia = ""; //
	var patronimico = ""; //
	var luogo_di_Nascita = ""; //
	var luogo_di_Morte = ""; //
	var genere = ""; //
	var data_di_Nascita = ""; //
	var data_di_Morte = ""; //
	var occupazione = ""; //
	var qualifica = ""; //
	var gruppi_di_appartenenza = ""; //
	var mittente = ""; //
	var destinatario = ""; //
	var luogo_di_Partenza = ""; //
	var luogo_di_Arrivo = ""; //
	var data_partenza = ""; //
	var data_arrivo = ""; //
	var lingua = ""; //
	var area_linguistica = ""; //
	var edizione = ""; //
	var antroponimo = ""; //
	var toponimo = ""; //
	var data = ""; //
	var letter_event = ""; //
	var infObj = ""; //

	var id = ""; //
	var dm = ""; //
	var mt = ""; //
	var loc = ""; //
	var tec = ""; //
	var at = ""; //
	var sg = ""; //
	var tt = ""; //
	var tp = ""; //
	var nt = ""; //
	var rf = ""; //
	var np = ""; //
	var nf = ""; //
	var pt = ""; //
	var ln = ""; //
	var lm = ""; //
	var gr = ""; //
	var dn = ""; //
	var dts = ""; //
	var oc = ""; //
	var qf = ""; //
	var ga = ""; //
	var mit = ""; //
	var des = ""; //
	var lp = ""; //
	var la = ""; //
	var dp = ""; //
	var da = ""; //
	var lin = ""; //
	var alin = ""; //
	var ed = ""; //
	var antr = ""; //
	var topo = ""; //
	var dt = ""; //

	for (let i = 0; i < params.length; i++) {
		if(params[i][0] == "Label" && (params[i][1] != "")) {
			label = "?label bif:contains \"\' "+ params[i][1] + " \'\" . ";
		}
		if(params[i][0] == "Identificatore" && (params[i][1] != "")) {
			id = " ?identifier";

			identificatore = "?subject crm:P1_is_identified_by ?uri_identifier . \
			?uri_identifier rdfs:label ?identifier . \
			?identifier bif:contains \"\'"+ params[i][1] +"\'\" . ";
		}
		if(params[i][0] == "Dimensione" && (params[i][1] != "")) {
			dm = " ?dimension";

			dimensione = "?subject crm:P43_has_dimension ?uri_dimension . \
			?uri_dimension rdfs:label ?dimension . \
			?dimension bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if(params[i][0] == "Materia" && (params[i][1] != "")) {
			mt = " ?material";

			materia = "?subject crm:P45_consists_of ?uri_material . \
			?uri_material rdfs:label ?material . \
			?material bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if(params[i][0] == "Localizzazione" && (params[i][1] != "")) {
			loc = " ?location";

			localizzazione = "?subject crm:P54_has_current_permanent_location ?uri_location . \
			?uri_location rdfs:label ?location . \
			?location bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if(params[i][0] == "Tecnica" && (params[i][1] != "")) {
			tec = " ?technique";

			tecnica = "?subject ?property ?event . \
			?event crm:P32_used_general_technique ?uri_technique . \
			?uri_technique rdfs:label ?technique . \
			?technique bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Artista" && (params[i][1] != "")) {
			at = " ?artist";

			artista = "?subject rdfs:label ?label .	\
			?production crm:P108_has_produced ?subject . \
			?pc crm:P01_has_domain ?production . \
			?pc crm:P02_has_range ?range . \
			?range rdfs:label ?artist . \
			?artist bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Soggetto" && (params[i][1] != "")) {
			sg = " ?depiction";

			soggetto = "?subject crm:P62_depicts ?uri_depiction . \
			?uri_depiction rdfs:label ?depiction . \
			?depiction bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Titolo" && (params[i][1] != "")) {
			tt = " ?title";

			infObj = "?subject crm:P128_carries ?information_object .";

			titolo = "?information_object crm:P1_is_identified_by ?uri_title . \
			?uri_title rdfs:label ?title . \
			?title bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Tipo" && (params[i][1] != "")) {
			tp = " ?type";

			infObj = "?subject crm:P128_carries ?information_object .";

			tipo = "?information_object crm:P2_has_type ?uri_type . \
			?uri_type rdfs:label ?type . \
			?type bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Note" && (params[i][1] != "")) {
			nt = " ?note";

			note = "?subject crm:P3_has_note ?uri_note . \
			?uri_note rdfs:label ?note . \
			?note bif:contains \"\'"+ params[i][1] +"\'\" .";
		}
		if (params[i][0] == "Riferimenti" && (params[i][1] != "")) {
			rf = " ?ref";

			riferimenti = "?subject crm:P67_refers_to ?uri_ref . \
			?uri_ref rdfs:label ?ref . \
			?ref bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Nome proprio" && (params[i][1] != "")) {
			np = " ?givenName";

			nome_proprio = "?subject foaf:givenName ?givenName . \
			?givenName bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Nome di famiglia" && (params[i][1] != "")) {
			nf = " ?familyName";

			nome_di_famiglia = "?subject foaf:familyName ?familyName . \
			?familyName bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Patronimico" && (params[i][1] != "")) {
			pt = " ?patronymic";

			patronimico = "?subject person:patronymicName ?patronymic . \
			?patronymic bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Luogo di Nascita" && (params[i][1] != "")) {
			ln = " ?birthPlace";

			luogo_di_Nascita = "?subject crm:P98i_was_born ?Birth . \
			?Birth crm:P7_took_place_at ?uri_birthPlace . \
			?uri_birthPlace rdfs:label ?birthPlace . \
			?birthPlace bif:contains \""+ params[i][1] +"\" . "
		}
		if (params[i][0] == "Luogo di Morte" && (params[i][1] != "")) {
			lm = " ?deathPlace";

			luogo_di_Morte = "?subject crm:P100i_died_in ?Death . \
			?Death crm:P7_took_place_at ?uri_deathPlace . \
			?uri_deathPlace rdfs:label ?deathPlace \
			?deathPlace bif:contains \""+ params[i][1] +"\" .	"
		}
		if (params[i][0] == "Genere" && (params[i][1] != "")) {
			gr = "?genere";

			genere = "?subject foaf:gender ?genere . \
			?genere bif:contains \""+ params[i][1] +"\" . "
		}
		if (params[i][0] == "Data di Nascita" && (params[i][1] != "")) {
			dn = " ?Birth_TS";

			data_di_Nascita = "?subject crm:P98i_was_born ?Birth . 	\
			?Birth crm:P4_has_time-span ?Birth_TS . \
			?Birth_TS rdfs:label \""+ params[i][1] +"\" ."
		}
		if (params[i][0] == "Data di Morte" && (params[i][1] != "")) {
			dts = " ?Death_TS";

			data_di_Morte = "?subject crm:P100i_died_in ?Death . \
			?Death crm:P4_has_time-span ?Death_TS . \
			?Death_TS rdfs:label \""+ params[i][1] +"\" . "
		}
		if (params[i][0] == "Qualifica" && (params[i][1] != "")) {
			qf = " ?qualification";

			qualifica = "?subject schema:honorificPrefix ?qualification . \
			?qualification bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Occupazione" && (params[i][1] != "")) {
			oc = " ?occupation";

			occupazione = "?subject schema:hasOccupation ?uriOccupation . \
			?uriOccupation rdf:type schema:Occupation; \
			rdfs:label ?occupation . \
			?occupation bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Gruppi di appartenenza" && (params[i][1] != "")) {
			ga = " ?group";

			gruppi_di_appartenenza = "?subject crm:P107i_is_current_or_former_member_of ?uriGroup . \
			?uriGroup rdfs:label ?group . \
			?group bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Mittente" && (params[i][1] != "")) {
			mit = " ?mittente";

			letter_event = "?subject crm:P25i_moved_by ?mov_ev . \
			?send rdfs:subClassOf ?mov_ev ; \
			rdf:type crm:EL2_Send_Letter . \
			?receive rdfs:subClassOf ?mov_ev; \
			rdf:type crm:EL3_Receive_Letter . ";

			mittente = "?send crm:P01_has_domain ?pcS . \
			?pcS crm:P02_has_range ?uriSender . \
			?uriSender rdfs:label ?mittente . \
			?mittente bif:contains \"\'"+ params[i][1] +"\'\" .	 "
		}
		if (params[i][0] == "Destinatario" && (params[i][1] != "")) {
			des = " ?destinatario";

			letter_event = "?subject crm:P25i_moved_by ?mov_ev . \
			?send rdfs:subClassOf ?mov_ev ; \
			rdf:type crm:EL2_Send_Letter . \
			?receive rdfs:subClassOf ?mov_ev; \
			rdf:type crm:EL3_Receive_Letter . ";

			destinatario = "?receive crm:P01_has_domain ?pcR . \
			?pcR crm:P02_has_range ?uriReceiver . \
			?uriReceiver rdfs:label ?destinatario . \
			?destinatario bif:contains \"\'"+ params[i][1] +"\'\" .	"
		}
		if (params[i][0] == "Luogo di Partenza" && (params[i][1] != "")) {
			lp = " ?luogo_partenza";

			letter_event = "?subject crm:P25i_moved_by ?mov_ev . \
			?send rdfs:subClassOf ?mov_ev ; \
			rdf:type crm:EL2_Send_Letter . \
			?receive rdfs:subClassOf ?mov_ev; \
			rdf:type crm:EL3_Receive_Letter . ";

			luogo_di_Partenza = "?send crm:P27_moved_from ?uriLuogoPartenza . \
			?uriLuogoPartenza rdfs:label ?luogo_partenza . \
			?luogo_partenza bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Luogo di Arrivo" && (params[i][1] != "")) {
			la = " ?luogo_arrivo";

			letter_event = "?subject crm:P25i_moved_by ?mov_ev . \
			?send rdfs:subClassOf ?mov_ev ; \
			rdf:type crm:EL2_Send_Letter . \
			?receive rdfs:subClassOf ?mov_ev; \
			rdf:type crm:EL3_Receive_Letter . ";

			luogo_di_Arrivo = "?receive crm:P26_moved_to ?uriLuogoArrivo . \
			?uriLuogoArrivo rdfs:label ?luogo_arrivo . \
			?luogo_arrivo bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Data partenza" && (params[i][1] != "")) {
			dp = " ?timeSpanSend";

			letter_event = "?subject crm:P25i_moved_by ?mov_ev . \
			?send rdfs:subClassOf ?mov_ev ; \
			rdf:type crm:EL2_Send_Letter . \
			?receive rdfs:subClassOf ?mov_ev; \
			rdf:type crm:EL3_Receive_Letter . ";

			data_partenza = "?send crm:P4_has_time-span ?time_spanS . \
			?time_spanS rdfs:label ?timeSpanSend . \
			?timeSpanSend bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Data arrivo" && (params[i][1] != "")) {
			da = " ?timeSpanReceive";

			letter_event = "?subject crm:P25i_moved_by ?mov_ev . \
			?send rdfs:subClassOf ?mov_ev ; \
			rdf:type crm:EL2_Send_Letter . \
			?receive rdfs:subClassOf ?mov_ev; \
			rdf:type crm:EL3_Receive_Letter . ";

			data_arrivo = "?receive crm:P4_has_time-span ?time_spanR . \
			?time_spanR rdfs:label ?timeSpanReceive .\
			?timeSpanReceive bif:contains \"\'"+ params[i][1] +"\'\" . "
		}
		if (params[i][0] == "Lingua" && (params[i][1] != "")) {
			lin = " ?lingua";

			infObj = "?subject crm:P128_carries ?information_object .";

			lingua = "?information_object crm:P72_has_language ?language . \
			?language rdfs:label ?lingua . \
			?lingua bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Area linguistica" && (params[i][1] != "")) {
			alin = " ?area_linguistica";

			infObj = "?subject crm:P128_carries ?information_object .";

			area_linguistica = "?information_object crm:P72_has_language ?language . \
			?language crm:P3_has_note ?area . \
			?area rdfs:label ?area_linguistica .\
			?area_linguistica bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Edizione" && (params[i][1] != "")) {
			ed = " ?edizione";

			infObj = "?subject crm:P128_carries ?information_object .";

			edizione = "?edition crm:P70_documents ?information_object ; \
			crm:P1_is_identified_by ?edition_id . \
			?edition_id rdfs:label ?edizione . \
			?edizione bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Toponimo" && (params[i][1] != "")) {
			topo = " ?toponimo";

			infObj = "?subject crm:P128_carries ?information_object .";

			toponimo = "?information_object crm:P67_refers_to ?link_toponimo . \
			?link_toponimo rdfs:label ?toponimo ; \
			crm:P2_has_type 'Toponimo' . \
			?toponimo bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Antroponimo" && (params[i][1] != "")) {
			antr = " ?antroponimo";

			infObj = "?subject crm:P128_carries ?information_object .";

			antroponimo = "?information_object crm:P67_refers_to ?link_antroponimo . \
			?link_antroponimo rdfs:label ?antroponimo; \
			crm:P2_has_type 'Antroponimo' . \
			?antroponimo bif:contains \"\'"+ params[i][1] +"\'\" ."
		}
		if (params[i][0] == "Data" && (params[i][1] != "")) {
			dt = " ?date";

			data = "?subject ?property ?event . \
			?event crm:P4_has_time-span ?uri_date . \
			?uri_date rdfs:label ?date . \
			?date bif:contains \"\'"+ params[i][1] +"\'\" ."
		}

	}


	prefixes = "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> \
	PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> \
	PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/> \
	PREFIX owl: <http://www.w3.org/2002/07/owl#> \
	PREFIX schema: <http://schema.org/> \
	PREFIX foaf: <http://xmlns.com/foaf/0.1/> \
	PREFIX person: <http://www.w3.org/ns/person#>"

	query = prefixes + " SELECT DISTINCT ?subject ?label" + id + dm + mt + loc + tec + at
	+ sg + tt + tp + nt + rf + np + nf + pt + ln + lm + gr + dn + dts + oc + qf + ga + mit 
	+ des + lp + la + dp + da + lin + alin + ed + antr + topo + dt + " \
	WHERE {GRAPH " + search_graph + " {?subject ?property ?object } \
	?subject rdfs:label ?label . " 
	+ infObj + letter_event + label + search_type + identificatore + dimensione + materia + localizzazione + tecnica 
	+ artista + titolo + tipo + note + riferimenti + nome_proprio + nome_di_famiglia
	+ patronimico + luogo_di_Nascita + luogo_di_Morte + genere + data_di_Nascita 
	+ data_di_Morte + qualifica + occupazione + gruppi_di_appartenenza + mittente + destinatario 
	+luogo_di_Partenza + luogo_di_Arrivo + data_partenza + data_arrivo + lingua 
	+ area_linguistica + edizione + toponimo + antroponimo + data + "}"

	var query_url = 'http://dev.restore.ovi.cnr.it:8890/sparql/?default-graph-uri=&query=' + encodeURIComponent(query) + '&output=json';

	console.log(query);

	$.ajax({

			url: query_url + '&callback=?',
			dataType: "json",
			success: function (data) {
				query_handle_json(data);
			},
			error: function (e) {}
		});

}

function query_handle_json(json) {

	console.log(json); 

		$('#query_results').text("");

		var i = 0;

		const first_row = [];

		$.each(
			json['head']['vars'],
			function (index, value) {
				first_row.push(value);
		});

		var t_head = '<div class="row t_head">';

		for (let k = 0; k < first_row.length; k++) {
			t_head += '<div class="col">' + first_row[k] + '</div>';
		}

		t_head += '</div>';


		$('#query_results').append(t_head);

		$.each(
			json['results']['bindings'],
			function (index, value) {
				var object = ""; 

				var link = value['subject']['value'];
				var label = value['label']['value'];

				object += '<div class="row"><div class="col">' + link + '</div><div class="col">' + label + '</div>';

				if (value.hasOwnProperty('identifier')) {
		          identifier = value['identifier']['value'];
		          object += '<div class="col">' + identifier + '</div>';
		        }
		        if (value.hasOwnProperty('dimension')) {
		          dimension = value['dimension']['value'];
		          object += '<div class="col">' + dimension + '</div>';
		        }
		        if (value.hasOwnProperty('material')) {
		          material = value['material']['value'];
		          object += '<div class="col">' + material + '</div>';
		        }
		        if (value.hasOwnProperty('location')) {
		          location = value['location']['value'];
		          object += '<div class="col">' + location + '</div>';
		        }
		        if (value.hasOwnProperty('technique')) {
		          technique = value['technique']['value'];
		          object += '<div class="col">' + technique + '</div>';
		        }
		        if (value.hasOwnProperty('artist')) {
		          artist = value['artist']['value'];
		          object += '<div class="col">' + artist + '</div>';
		        }
		        if (value.hasOwnProperty('depiction')) {
		          depiction = value['depiction']['value'];
		          object += '<div class="col">' + depiction + '</div>';
		        }
		        if (value.hasOwnProperty('title')) {
		          title = value['title']['value'];
		          object += '<div class="col">' + title + '</div>';
		        }
		        if (value.hasOwnProperty('type')) {
		          type = value['type']['value'];
		          object += '<div class="col">' + type + '</div>';
		        }
		        if (value.hasOwnProperty('note')) {
		          note = value['note']['value'];
		          object += '<div class="col">' + note + '</div>';
		        }
		        if (value.hasOwnProperty('ref')) {
		          ref = value['ref']['value'];
		          object += '<div class="col">' + ref + '</div>';
		        }
		        if (value.hasOwnProperty('givenName')) {
		          givenName = value['givenName']['value'];
		          object += '<div class="col">' + givenName + '</div>';
		        }
		        if (value.hasOwnProperty('familyName')) {
		          familyName = value['familyName']['value'];
		          object += '<div class="col">' + familyName + '</div>';
		        }
		        if (value.hasOwnProperty('patronymic')) {
		          patronymic = value['patronymic']['value'];
		          object += '<div class="col">' + patronymic + '</div>';
		        }
		        if (value.hasOwnProperty('birthPlace')) {
		          birthPlace = value['birthPlace']['value'];
		          object += '<div class="col">' + birthPlace + '</div>';
		        }
		        if (value.hasOwnProperty('deathPlace')) {
		          deathPlace = value['deathPlace']['value'];
		          object += '<div class="col">' + deathPlace + '</div>';
		        }
		        if (value.hasOwnProperty('genere')) {
		          genere = value['genere']['value'];
		          object += '<div class="col">' + genere + '</div>';
		        }
		        if (value.hasOwnProperty('Birth_TS')) {
		          Birth_TS = value['Birth_TS']['value'];
		          object += '<div class="col">' + Birth_TS + '</div>';
		        }
		        if (value.hasOwnProperty('Death_TS')) {
		          Death_TS = value['Death_TS']['value'];
		          object += '<div class="col">' + Death_TS + '</div>';
		        }
		        if (value.hasOwnProperty('qualification')) {
		          qualification = value['qualification']['value'];
		          object += '<div class="col">' + qualification + '</div>';
		        }
		        if (value.hasOwnProperty('occupation')) {
		          occupation = value['occupation']['value'];
		          object += '<div class="col">' + occupation + '</div>';
		        }
		        if (value.hasOwnProperty('group')) {
		          group = value['group']['value'];
		          object += '<div class="col">' + group + '</div>';
		        }
		        if (value.hasOwnProperty('mittente')) {
		          mittente = value['mittente']['value'];
		          object += '<div class="col">' + mittente + '</div>';
		        }
		        if (value.hasOwnProperty('destinatario')) {
		          destinatario = value['destinatario']['value'];
		          object += '<div class="col">' + destinatario + '</div>';
		        }
		        if (value.hasOwnProperty('luogo_partenza')) {
		          luogo_partenza = value['luogo_partenza']['value'];
		          object += '<div class="col">' + luogo_partenza + '</div>';
		        }
		        if (value.hasOwnProperty('luogo_arrivo')) {
		          luogo_arrivo = value['luogo_arrivo']['value'];
		          object += '<div class="col">' + luogo_arrivo + '</div>';
		        }
		        if (value.hasOwnProperty('timeSpanSend')) {
		          timeSpanSend = value['timeSpanSend']['value'];
		          object += '<div class="col">' + timeSpanSend + '</div>';
		        }
		        if (value.hasOwnProperty('timeSpanReceive')) {
		          timeSpanReceive = value['timeSpanReceive']['value'];
		          object += '<div class="col">' + timeSpanReceive + '</div>';
		        }
		        if (value.hasOwnProperty('lingua')) {
		          lingua = value['lingua']['value'];
		          object += '<div class="col">' + lingua + '</div>';
		        }
		        if (value.hasOwnProperty('area_linguistica')) {
		          area_linguistica = value['area_linguistica']['value'];
		          object += '<div class="col">' + area_linguistica + '</div>';
		        }
		        if (value.hasOwnProperty('edizione')) {
		          edizione = value['edizione']['value'];
		          object += '<div class="col">' + edizione + '</div>';
		        }
		        if (value.hasOwnProperty('toponimo')) {
		          toponimo = value['toponimo']['value'];
		          object += '<div class="col">' + toponimo + '</div>';
		        }
		        if (value.hasOwnProperty('antroponimo')) {
		          antroponimo = value['antroponimo']['value'];
		          object += '<div class="col">' + antroponimo + '</div>';
		        }
		        if (value.hasOwnProperty('date')) {
		          date = value['date']['value'];
		          object += '<div class="col">' + date + '</div>';
		        } 

		        object += '</div>';

				i++;

				/*onclick=copy__Text("' + value['link']['value'] + '")*/
				$('#query_results').append(object);
				

			});

		if (i==0) {
			var message = '<p>Nessun risultato trovato</p>';
			$('#query_results').append(message);
		}
}
